using System;
using System.Collections;
using System.Text.RegularExpressions;

namespace JobSync
{
   class SyncFromP4 : SyncTTP
   {
      protected string m_strChangelist;

      public SyncFromP4(SPSTools.Logger p_logger, string p_strTTUrl, string p_strUsername, string p_strPassword, string p_strChangelist)
         : base(p_logger, p_strTTUrl, p_strUsername, p_strPassword)
      {
         m_strChangelist = p_strChangelist;
      }

      public bool run(string p_strProject)
      {
         bool fResult = false;
         try
         {
            ArrayList listChanges = new ArrayList();
            listChanges.Add(m_strChangelist); // temp list

            ArrayList list = getFiles(listChanges); // fetch files

            ArrayList listDefects = getDefectNums(m_strChangelist);
            for (int i = 0; i < listDefects.Count; ++i)
            {
               fResult = m_engine.updateDefect(p_strProject, (string)listDefects[i], list);
               m_logger.log("Defect " + (string)listDefects[i] + " updated successfully");
            }
         }
         catch (Exception p_exception)
         {
            m_logger.log("SyncTTP Failed: " + p_exception.Message);
         }
         finally { m_p4api.Disconnect(); }
         return (fResult);
      }

      protected ArrayList getDefectNums(string p_strChangelist)
      {
         ArrayList list = new ArrayList();
         try
         {
            m_p4api.Tagged();
            m_p4api.Connect();
            m_p4api.ExceptionLevel = 1; // 0 - No exceptions, 1 - Exception on error, 2 - Exception on error or warning.

            Array aJobs = m_p4api.run("describe " + p_strChangelist);
            for (int i = 0; i < aJobs.Length; ++i)
            {
               if (!((string)aJobs.GetValue(i)).StartsWith("jobstat") && ((string)aJobs.GetValue(i)).StartsWith("job"))
               {
                  string strJob = ((string)aJobs.GetValue(i));
                  int iPos = strJob.IndexOf(' ');
                  if (iPos >= 0)
                  {
                     Array aJob = m_p4api.run("job -o " + strJob.Substring(iPos + 1, strJob.Length - iPos - 1));
                     if (aJob != null && aJob.Length > 0)
                     {
                        int iPosS = ((string)aJob.GetValue(0)).IndexOf("DefectNum");
                        int iPosE = ((string)aJob.GetValue(0)).IndexOf("\n", iPosS);
                        if (iPosS >= 0 && iPosE > iPosS) { list.Add(((string)aJob.GetValue(0)).Substring(iPosS+10, iPosE-iPosS-10).Trim()); }
                     }
                  }
               }
            }

         }
         catch (Exception p_exception) {}
         finally { m_p4api.Disconnect(); }
         return (list);
      }
   }
}
